#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#define FOSC 12000000 //onboard osc
#define BAUD 9600
#define MYUBRR FOSC/16/BAUD-1


#define sbi(reg,bit)((reg) |= (1<<(bit)))
#define cbi(reg,bit)((reg) &= ~(1<<(bit)))
#define outb(reg,data) ((reg)=(data))
#define inp(reg) (reg)

#include "mmc.c"

//Define functions
//======================
void testSDCard();
//======================

int main (void) {
  DDRC |= 0xC0;
  PORTC |= 0xC0;
  testSDCard();
  while(1);
}

/* make flash w red LED */
void flashRed() {
  unsigned int a;
  for(a=65535; a!=0; a--) {
    PORTC &= ~0x80;
  }

  for(a=65535; a!=0; a--) {
    PORTC |= 0x80;
  }
}

/* make long flash w red LED */
void longRed() {
  unsigned long a;
  for(a=5000000; a!=0; a--) {
    PORTC &= ~0x80;
  }

  for(a=1; a!=0; a++) {
    PORTC |= 0x80;
  }
}

/* make long flash w green LED */
void longGreen() {
  unsigned long a;
  for(a=5000000; a!=0; a--) {
    PORTC &= ~0x40;
  }

  for(a=65535; a!=0; a--) {
    PORTC |= 0x40;
  }
}

void testSDCard() {
  unsigned char Timeout = 0;
  //  char a = 1;
  int i = 1;
  while (i !=0) 
    // ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten
    // MMC/SD-Karte wird dann neu Initialisiert
    {
      i = Init_MMC();
      if (i != 0) {
	flashRed();
      }
      Timeout++;
      if (Timeout == 200) {
	longRed();
	break;
      }
    }
  //Initialisierung der MMC/SD-Karte ENDE!
  
  
  /* Flash "Init OK" signal. Never happens.... */
  longGreen();


  
  // Ignore the rest...



  unsigned char Buffer[512];
  long addr = 0;
  unsigned char tmp = 0;
  
  //Erzeugt ein  Array von 512 Bytes mit dem Inhalt EEhex
  
  for (i=0;i<512;i=i+1) {
      Buffer[i] = 0xEE;
    }
  
  //schreibt Array in den ersten Blocks der MMC/SD Karte (addr = 0)
  tmp = Write_Block_MMC (addr, Buffer);
  if (tmp != 0) //ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten 
    {
      printf("Error %x\n",tmp);
    }
  
  //auslesen des zweiten Blocks von der MMC/SD Karte (addr = 1)
  addr = 1;
  tmp = Read_Block_MMC (addr,Buffer);
  if (tmp != 0) //ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten 
    {
      printf("Error %x\n",tmp);
    }
  //ausgabe des zweiten Blocks auf die serielle Schnittstelle
  for (i=0;i<512;i=i+8)
    {
      printf("%x %x %x %x %x %x %x %x ",Buffer[i],Buffer[i+1],Buffer[i+2],Buffer[i+3],Buffer[i+4],Buffer[i+5],Buffer[i+6],Buffer[i+7]);
      i=i+8;
      printf("%x %x %x %x %x %x %x %x\n",Buffer[i],Buffer[i+1],Buffer[i+2],Buffer[i+3],Buffer[i+4],Buffer[i+5],Buffer[i+6],Buffer[i+7]);
    }
  
  
 //auslesen des ersten Blocks von der MMC/SD Karte (addr = 1)
  addr = 0;
  tmp = Read_Block_MMC (addr,Buffer);
  if (tmp != 0) //ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten 
    {
      printf("Error %x\n",tmp);
    }
  //ausgabe des ersten Blocks auf die serielle Schnittstelle
  for (i=0;i<512;i=i+8)
    {
      printf("%x %x %x %x %x %x %x %x ",Buffer[i],Buffer[i+1],Buffer[i+2],Buffer[i+3],Buffer[i+4],Buffer[i+5],Buffer[i+6],Buffer[i+7]);
      i=i+8;
      printf("%x %x %x %x %x %x %x %x\n",Buffer[i],Buffer[i+1],Buffer[i+2],Buffer[i+3],Buffer[i+4],Buffer[i+5],Buffer[i+6],Buffer[i+7]);

    }
}
